-- srb2k script by Dr Nope , ported in RR by Indev
local TICRATE= TICRATE

local CV_NETVAR= CV_NETVAR

local SKSKPOWR= SKSKPOWR

local V_ALLOWLOWERCASE= 0 -- Doesn't exists, its now inverted and is "V_FORCEUPPERCASE"
local V_HORZSCREEN= V_HORZSCREEN
local V_SPLITSCREEN= V_SPLITSCREEN

local S_SetInternalMusicVolume = rawget(_G, "S_SetInternalMusicVolume")

-- It's gone in RR atm, so i'll put a placeholder for now
if S_SetInternalMusicVolume == nil then
    S_SetInternalMusicVolume = function(...) end
end

-- Those don't exist now, gotta reimplement
local function G_RaceGametype()
    return gametyperules & GTR_CIRCUIT
end

freeslot("S_GMAX_PARTICLE1", "S_GMAX_PARTICLE2", "S_GMAX_PARTICLE3", "S_GMAX_PARTICLE4", "S_GMAX_PARTICLE5", "S_GMAX_PARTICLE6", "MT_GMAX_PARTICLE1",
    "sfx_eeving", "sfx_evsucc", "sfx_evgmax", "sfx_evgnah"
)

states[S_GMAX_PARTICLE1] = {
	sprite = SPR_CLAS,
	tics = 3,
	frame = A,
	nextstate = S_GMAX_PARTICLE2
}

states[S_GMAX_PARTICLE2] = {
	sprite = SPR_CLAS,
	tics = 3,
	frame = B,
	nextstate = S_GMAX_PARTICLE3
}

states[S_GMAX_PARTICLE3] = {
	sprite = SPR_CLAS,
	tics = 3,
	frame = C,
	nextstate = S_GMAX_PARTICLE4
}

states[S_GMAX_PARTICLE4] = {
	sprite = SPR_CLAS,
	tics = 3,
	frame = D,
	nextstate = S_GMAX_PARTICLE5
}

states[S_GMAX_PARTICLE5] = {
	sprite = SPR_CLAS,
	tics = 3,
	frame = E,
	nextstate = S_GMAX_PARTICLE6
}

states[S_GMAX_PARTICLE6] = {
	sprite = SPR_CLAS,
	tics = 3,
	frame = F,
}

mobjinfo[MT_GMAX_PARTICLE1] = {
	spawnstate = S_GMAX_PARTICLE1,
	flags = MF_NOCLIP|MF_NOCLIPHEIGHT
}

-- I recycled this effect from Ditto for the Gigamax transform,
-- cuz ima lazy
local function _gmaxFX(pmo, infx)
	infx= (infx==nil) or infx

	local qsfx= (sfx==sfx_incopy and sfx_decopy or sfx_incopy)

	local copy_particle = P_SpawnMobj(pmo.x, pmo.y, pmo.z, MT_GMAX_PARTICLE1)
	copy_particle.angle = pmo.angle
	copy_particle.target = pmo

    if S_SoundPlaying(pmo, (infx and sfx_evgnah or sfx_evgmax)) then
        S_StopSoundByID(pmo, (infx and sfx_evgnah or sfx_evgmax))
    end
    S_StartSound(pmo, (infx and sfx_evgmax or sfx_evgnah))
end


-- it takes this long to evolve?
-- local EEVEELUTION_DURATION= 9*TICRATE
local CV_eeveelution_duration= CV_RegisterVar({
    name= "eeveelution_duration",
    defaultvalue= "9",
    PossibleValue= CV_Natural,
    flags= CV_NETVAR
})
local function EEVEELUTION_DURATION()
    local r= ( (CV_eeveelution_duration and CV_eeveelution_duration.value)
        and CV_eeveelution_duration.value
        or  9
    )
    return r*TICRATE
end

-- gigamaxing chance instead of eevolving
-- local GIGAMAX_PERCENT_CHANCE= 3
local CV_gigamax_percent_chance= CV_RegisterVar({
    name= "eeveelution_gmax_chance",
    defaultvalue= "3",
    PossibleValue= {MIN= 0, MAX= 100},
    flags= CV_NETVAR
})
local function GIGAMAX_PERCENT_CHANCE()
    return ( (CV_gigamax_percent_chance and CV_gigamax_percent_chance.value and
            CV_gigamax_percent_chance.value>=0 and CV_gigamax_percent_chance.value<=100
        )
        and CV_gigamax_percent_chance.value
        or  3
    )
end

-- NET Cmd - player facing
-- do you want to  eevolve or nah?
COM_AddCommand("eeveelution",
	function(player,arg)
		if arg==nil then
			CONS_Printf(player, "eeveelution is \""..(player.eevee_active and "On" or "Off")..'"')

			return
		end

		local n= tonumber(arg)
		if n==nil then
			arg= arg:lower()
			n= (arg=="true" or arg=="on" or arg=="yes")
		end

		player.eevee_active= n
	end
)

-- list of eeveelution, each given an id and their skin name
--  id are used to form a stackable configuration for maps,
--   that's why their power of twos, I unadvise changing the ids
rawset(_G, "EEVEELUTION", {
    EEVEE= {id=0,skin="eevee"},

    VAPOREON= {id=1,skin="vaporeon"},
    JOLTEON= {id=2, skin="jolteon"},
    FLAREON= {id=4, skin="flareon"},
    ESPEON= {id=8, skin="espeon"},
    UMBREON= {id=16, skin="umbreon"},
    LEAFEON= {id=32, skin="leafeon"},
    GLACEON= {id=64, skin="glaceon"},
    SYLVEON= {id=128, skin="sylveon"},

    GIGANTAMAX= {id=2048, skin="gmaxeevee"}
})

-- used for possible error control, don't change this, unless more
--  eeveelutions came up (where are the poison/steel/rock evees gamefreak?!)
local _eeveemaxid= 255 -- = last_eevveelution.id * 2 - 1


-- current state of eevee player (not stackable)
local EEVEE_STATE= {
    NOTHING= 0, -- chilling
    MISSED= 1, -- just go its eeveelution canceled
    EEVOLVING= 2, -- what? EEVEE is evolving?!
    EEVOLVED= 3, -- who's the good eevolved boi?! Yes you are!
    GIGAMAXED= 4 -- uh oh
}


-- the main table that will store every possible eeveeconfig for given maps
local EeveelutionMapTable= {}


-- process and safe check a given eeveelution, be it a string or a id number,
--  and returns the corresponding eeveeconfig number
local function _singleEeveelutionProcess(eeveelution)
    if not eeveelution then return end

    if type(eeveelution)=="string" then
        local tmp= EEVEELUTION[eeveelution:upper()]
        if tmp==nil or not tmp.id then
            print("[Eeveelution] Error: '"..eeveelution.."' is an unknown eeveelution...")
            return nil
        end

        return tmp.id
    elseif type(eeveelution)=="number" then
        local tmp= math.floor(eeveelution)
        if tmp>_eeveemaxid or tmp<0 then
            print("[Eeveelution] Error: '"..eeveelution.."' is an unmatched eeveelution id...")
            return nil
        end

        return tmp
    end

    return nil
end

-- function that registers the eeveeconfigs for each map inside the main table
--  'mapid' parameter is the 2-character ID corresponding to the targeted map
--  'eeveelutions' is an evolution config to assign to the corresponding map,
--      be it a string, an eeveeconfig number, or a table containing these
--  'encore' is a boolean, telling if the config will be applied to 'encore'
--      version of the given map (if not given, considered to 'false')
local function registerEeveelutionMap(mapid, eeveelutions, encore)
    mapid = mapid:upper()

    encore= ($~=nil and $ or false)

    -- Hmmm… actually, maybe it's better if I don't use this...
    -- ... in case some maps are loaded after this script...
	-- if (mapheaderinfo[map_realid] == nil) then
    --     print("[Eeveelution - EEVEELUTION_mapRegister] Error: couldn't register eeveelution for unknown map "..mapid)
    --     return
    -- end

    local eeveelution_choice= 0
    if (type(eeveelutions)=="table") then
        for i=1,(#eeveelutions) do
            local eeveelution= _singleEeveelutionProcess(eeveelutions[i])

            if eeveelution then
                eeveelution_choice= $ | eeveelution
            end
        end
    elseif _singleEeveelutionProcess(eeveelutions) then
        eeveelution_choice= eeveelutions
    else
        print("[Eeveelution - EEVEELUTION_mapRegister] Error: bad eeveelution identifier given...")
        return
    end

    if not EeveelutionMapTable[mapid] then
        EeveelutionMapTable[mapid]=
            (not encore) and
                {base= eeveelution_choice}
            or
                {encore= eeveelution_choice}
    else
        if (not encore) then
            EeveelutionMapTable[mapid].base= eeveelution_choice
        else
            EeveelutionMapTable[mapid].encore= eeveelution_choice
        end

        print("-- Eeveelution registered for map "..mapid..(encore and "'s encore" or ""))
    end
end

-- the globally registered function for external scripts to register the eeveelutions
--  for particular maps
-- Example of how to register and eevolution for a given map:
--      EEVEELUTION_mapRegister(
--          {map="XX", eeveelution={"umbreon"}}, -- setting eeveelution for map YY
--          {map="YY", eeveelution={"glaceon"}, encore=true} -- ... for encore version of map YY
--      )
--  * the 'map' parameter is a string that this the id of the map
--  * the 'eeveelution' parameter is a table containing the eeveelution to register for given map
--       - possible value are the following strings:
--              "vaporeon", "jolteon", "flareon", "espeon", "umbreon", "leafeon", "glaceon" or "sylveon"
--
--  * encore is an optional parameter for the 'encore' version of the map.
--      If set to 'true', the eeveelution for will override the one given for the base map
--      If not given (or set to 'false'), the eeveelution for the base map and the encore version will
--          be the same.
--
-- Note: you can give several eeveelution for a map (ex: eeveelution={"espeon","glaceon"}), in this case
--      the eeveelution for each player during the game will be chose randomly
rawset(_G, "EEVEELUTION_mapRegister", function(...)
    local args = {...}

    for i=1,#args do
        local arg= args[i]

        if arg and arg.map and arg.eeveelution then
            registerEeveelutionMap(arg.map, arg.eeveelution, arg.encore)
        else
            print("[Eeveelution - EEVEELUTION_mapRegister] Error: missing data"..
                (arg.map==nil) and "- no map given"
                    or ((arg.eeveelution==nil) and "- no eeveelution given" or "")
            )
        end
    end
end)

-- NETVAR
-- should we fallback to a random selection if no eeveelution registered
--  for the played map
local cv_rng_fallback= CV_RegisterVar({
    name="eeveelution_rng_fallback",
    defaultvalue="On",
    flags= CV_NETVAR,
    PossibleValue= CV_OnOff
})

-- tell if player is currently playing a skin registered as an eeveelution
--  (returns a boolean)
local function isPlayerAnEeveelution(player)
    if (not (player.valid and player.mo)) or player.spectator then
        return false
    end

    for name, obj in pairs(EEVEELUTION) do
        if obj and obj.skin and obj.skin==player.mo.skin then
            return true
        end
    end

    return false
end

-- function that initiate and eevee player's eeveelution
-- the eeveelution is, ofc, randomly chosen amongst the candidates
--  registered for the currently played map
local function eevolve(player)
    local pickEeveelution_skin= nil
    local b_somecandidates= server.eeveelution_map_candidates and
                                (#server.eeveelution_map_candidates>0)
    -- if no eeveelution candidates given for current map
    --  (an rng_fallback CVAR set to 'on'), randomly chose an
    --  eeveelution among all the possibilities
    if (not b_somecandidates) then
        if cv_rng_fallback.value then
            local pick= P_RandomRange(1,8)
            local i=1
            local b_atleastOne= true
            while (i<=pick and b_atleastOne) do
                b_atleastOne= false
                for k,v in pairs(EEVEELUTION) do
                    if v and v.skin and skins[v.skin] and v.id and v.id>0 and v.id<_eeveemaxid then
                        if i==pick then
                            pickEeveelution_skin= v.skin
                        end
                        i= $+1
                        b_atleastOne= true
                    end
                end
            end
        end

        -- no pick possible? fuck it!
        if (not player.eeveelution)
            or ((not pickEeveelution_skin) and (not b_somecandidates))
        then
            return
        end
    end

    -- pick an eeveelution among candidates (if choice not already made)
    local _s= #server.eeveelution_map_candidates
    pickEeveelution_skin= ($~=nil) and $ or (
            (_s==1)
                and server.eeveelution_map_candidates[1]
                or  server.eeveelution_map_candidates[P_RandomRange(1,_s)]
        )

    -- whoopsie
    if (not pickEeveelution_skin) or (not skins[pickEeveelution_skin]) then
        print("[Eevolve] Error trying to access skin "..(
            (pickEeveelution_skin==nil) and '{nil value}'
                or ('"'..pickEeveelution_skin..'"')
            )
        )

        return
    end

    -- EEVEELUTION! ENGAGE! *_*
    player.eeveelution.state= EEVEE_STATE.EEVOLVING
    player.eeveelution.target= pickEeveelution_skin
    player.eeveelution.timer= 0
end


-- deevolve an eevolved eevee player
-- in practice this is used to flush out some unwanted stuff
-- if 'eevee' (default: true) makes sure the player's skin reverts to eevee
local function deevolve(player, eevee)
    eevee= (eevee==nil) or eevee
    if player.valid and player.mo and player.eeveelution then
        S_SetInternalMusicVolume(200,player)

        if player.eeveelution.target then
            local _skin= skins[player.eeveelution.target]
            if player.eeveelution.hadPrefColor then
                if player.skincolor==_skin.prefcolor then
                    player.skincolor= skins[EEVEELUTION.EEVEE.skin].prefcolor
                else
                    player.eeveelution.hadPrefColor= player.skincolor
                end

                -- G_GamestateUsesLevel is not exposed so shrug
                pcall(function() player.mo.color = player.skincolor end)
            end
        end
        if eevee then
            R_SetPlayerSkin(player, EEVEELUTION.EEVEE.skin)
        end

        local cur_skin= skins[player.mo.skin]
        if not player.HMRs then --if HOSTMOD's restat, let it do its thing
            player.kartspeed= cur_skin.kartspeed
            player.kartweight= cur_skin.kartweight
        end
        player.eeveelution= nil
    end
end

-- cancel an eevee player's ongoing eevolution process
local function cancelEevolving(player)
    if not (player.valid and player.mo and player.eeveelution
            and player.eeveelution.state==EEVEE_STATE.EEVOLVING)
    then
        return
    end

    if(S_SoundPlaying(player.mo, sfx_eeving)) then
        S_StopSoundByID(player.mo, sfx_eeving)
    end

    S_SetInternalMusicVolume(200,player)

    -- nope, back to square one
    player.eeveelution.state= EEVEE_STATE.MISSED
    player.mo.skin= EEVEELUTION.EEVEE.skin
    R_SetPlayerSkin(player, player.mo.skin)
    player.mo.color= player.skincolor
    player.eeveelution.timer= 0
end

-- function called to advance the eeveelution process
local function eevolving(player)
    if (not (player.valid and player.mo and player.eeveelution))
        or not (player.eeveelution.state==EEVEE_STATE.EEVOLVING and player.eeveelution.target)
    then
        return
    end

	-- 1, bc sound must be distant from the 'new lap' sound
	-- otherwise, small lag
    if player.eeveelution.timer==1 then
        S_StartSound(player.mo, sfx_eeving)
        S_SetInternalMusicVolume(50,player)

        player.eeveelution.timer= $+1
        return
    end

    -- got into trouble will eevolving? too bad!
    if player.respawn.state then
        cancelEevolving(player)

        return
    end

    local eeveeSkin= skins[EEVEELUTION.EEVEE.skin]
    local targetSkin= skins[player.eeveelution.target]
    --whoops
    if not targetSkin then
        print("[Eevolve] Error: no target skin \""..player.eeveelution.target..'"')
        cancelEevolving(player)
        return
    end
    local b_prefColor= (player.skincolor==eeveeSkin.prefcolor)
    -- when the eeveelution process is finally over, do all the stuff
    if player.eeveelution.timer==EEVEELUTION_DURATION() then
        if(S_SoundPlaying(player.mo, sfx_eeving)) then
            S_StopSoundByID(player.mo, sfx_eeving)
        end

        player.eeveelution.state= EEVEE_STATE.EEVOLVED
        player.mo.skin= player.eeveelution.target
        R_SetPlayerSkin(player, player.mo.skin)
        player.skincolor= b_prefColor and targetSkin.prefcolor or $

        if not player.HMRs then --if HOSTMOD's restat, let it do its thing
            player.kartspeed= targetSkin.kartspeed
            player.kartweight= targetSkin.kartweight
        end

        S_StartSound(player.mo, sfx_evsucc)
        S_StartSound(player.mo, targetSkin.soundsid[SKSKPOWR])
    -- advancing in the eeveelution process
    --  (blinking skin trandition and all that stuff)
    else
		if player.eeveelution.timer==0 then
			player.eeveelution.timer= $+1
            player.eeveelution.hadPrefColor= b_prefColor
			return
		end
        local freq= TICRATE-((player.eeveelution.timer*TICRATE)/EEVEELUTION_DURATION())

        local _ss, _sw= player.kartspeed, player.kartweight
        if player.eeveelution.timer%freq == 0 then
            player.mo.color= b_prefColor and targetSkin.prefcolor or $
            player.mo.skin= player.eeveelution.target
        else
            player.mo.skin= EEVEELUTION.EEVEE.skin
            player.mo.color= player.skincolor
        end
        if not player.HMRs then --if HOSTMOD's restat, let it do its thing
            player.kartspeed= eeveeSkin.kartspeed
            player.kartweight= eeveeSkin.kartweight
        end

        player.eeveelution.timer= $+1
    end
end

-- function called once eevee as eevolved, make sure he stays that way
local function eevolved(player)
    if (not (player.valid and player.mo and player.eeveelution))
        or not (player.eeveelution.state==EEVEE_STATE.EEVOLVED and player.eeveelution.target)
        or (not player.eeveelution.timer) or player.eeveelution.timer<EEVEELUTION_DURATION()
    then
        return
    end

    if player.eeveelution.timer == EEVEELUTION_DURATION()+4*TICRATE then
        S_SetInternalMusicVolume(200,player)
    end

    player.eeveelution.timer= $+1

    -- let's keep the eevolved skin, even after falling of a cliff
    if player.respawn.state and
        player.mo.skin==EEVEELUTION.EEVEE.skin
    then
        player.mo.skin= player.eeveelution.target
        R_SetPlayerSkin(player, player.mo.skin)
    end
end

-- function called when the player's eevlution has been interrupted
--  (basically just maintain the state for a particular duration)
local function missedEevolution(player)
    if not (player.valid and player.mo and player.eeveelution
            and player.eeveelution.state==EEVEE_STATE.MISSED)
    then
        return
    end

    -- the 'missed' state goes for that long
    if player.eeveelution.timer==(3*TICRATE) then
        player.eeveelution.state=EEVEE_STATE.NOTHING
        player.eeveelution.timer= 0
    end

    S_SetInternalMusicVolume(200, player)

    player.eeveelution.timer= $+1

end

-- function called to roll the dice to see if the player will get a gigamax
--  and if so, initiate the gigamax phase
-- returns a boolean wheter or not the gigamaxing happened
local function gigamaxRoll(player)
    if not (player.valid and player.eeveelution
            and player.mo and player.mo.skin==EEVEELUTION.EEVEE.skin)
    then
        return
    end

    -- what? tehre's actually no gigamax skin? shame!
    if not (EEVEELUTION.GIGANTAMAX.skin and skins[EEVEELUTION.GIGANTAMAX.skin]) then
        --print("[Eevee gigamax] Error: gigantamax skin \""
        --        ..EEVEELUTION.GIGANTAMAX.skin.."\" not found."
        --)

        return
    end
    local gmax_skin= skins[EEVEELUTION.GIGANTAMAX.skin]

    -- roll the dice!
    local roll= P_RandomRange(1,100)
    local b_gigamax= (roll<=GIGAMAX_PERCENT_CHANCE())

    -- GIGANTAMAX! lol
    if b_gigamax then
        player.eeveelution.state= EEVEE_STATE.GIGAMAXED
        player.mo.skin= EEVEELUTION.GIGANTAMAX.skin
        player.eeveelution.timer= 0
        _gmaxFX(player.mo)

        if not player.HMRs then --if HOSTMOD's restat, let it do its thing
            player.kartspeed= gmax_skin.kartspeed
            player.kartweight= gmax_skin.kartweight
        end
    end

    -- lol did it actually happened?
    return b_gigamax
end

-- function called when eevee player has been gigamexed
--  (just making sure some stuff happens)
local function gigamaxed(player)
    if not (player.valid and player.eeveelution
        and player.mo and player.eeveelution.state==EEVEE_STATE.GIGAMAXED)
    then
        return
    end

    local targetSkin= skins[EEVEELUTION.GIGANTAMAX.skin]
    if player.eeveelution.timer==TICRATE/3 then
        S_StartSound(player.mo, targetSkin.soundsid[SKSKPOWR])
    end

    -- let's keep the gigamaxed skin, even after falling of a cliff
    if player.respawn.state and
        player.mo.skin==EEVEELUTION.EEVEE.skin
    then
        player.mo.skin= EEVEELUTION.GIGANTAMAX.skin
    end

    player.eeveelution.timer= $+1
end

-- called when time to end gigamax stuff
local function ungigamax(player)
    if not (player.valid and player.eeveelution
        and player.mo and player.eeveelution.state==EEVEE_STATE.GIGAMAXED)
    then
        return
    end

    if player.mo.skin==EEVEELUTION.GIGANTAMAX.skin then
        player.mo.skin= EEVEELUTION.EEVEE.skin
        R_SetPlayerSkin(player, player.mo.skin)

        local eevee_skin= skins[EEVEELUTION.EEVEE.skin]
        if not player.HMRs then --if HOSTMOD's restat, let it do its thing
            player.kartspeed= eevee_skin.kartspeed
            player.kartweight= eevee_skin.kartweight
        end
    end
    player.eeveelution.state= EEVEE_STATE.NOTHING
    player.eeveelution.timer= nil
    _gmaxFX(player.mo, false)
end


-- making sure we clean stuff in-between races
local _cleaning= 0
local r_numlaps= nil
-- 'lvl' indicates the step to which the 'cleaning' is done
local function cleaning(lvl)
	if _cleaning==lvl then return end

	for player in players.iterate do
		deevolve(player)
	end
	_cleaning= lvl
    r_numlaps= nil
end

-- ah, the 'ThinkFrame' hook, where all the rage is at
addHook("ThinkFrame", function()
    -- in race, this is based on the canon number of laps of the map
    if not r_numlaps then
        r_numlaps= mapheaderinfo[gamemap].numlaps
    end

    -- at the start, don't forget to lookup for the possible eeveelution candidates
    if leveltime==1 then
        local gamemapid = G_BuildMapName(gamemapid)

        server.eeveelution_map_candidates= {}
        local evee_obj= EeveelutionMapTable[gamemapid]
        if evee_obj~=nil then
            local mapEeveelutions=
                (encoremode and evee_obj.encore)
                    and evee_obj.encore
                    or  evee_obj.base
            for name, obj in pairs(EEVEELUTION) do
                if obj and obj.id and obj.skin and skins[obj.skin]
                    and ( obj.id & mapEeveelutions )
                then
                    table.insert(server.eeveelution_map_candidates, obj.skin)
                end
            end
        end
    end

    for player in players.iterate do
        player.eevee_active= ($==nil) and true or $

        -- flushing the previous eevee stuff before the race
        if leveltime==0 then
            deevolve(player)

            continue
        end

        if (not (player.valid and player.mo)) or player.spectator
            or (not player.eevee_active)
            or player.is_actually_a_ditto --trust me, better if we leave ditto out of this
        then
            player.eeveelution= nil
            continue
        end

        if player.mo.skin~=EEVEELUTION.EEVEE.skin
            and ( (not isPlayerAnEeveelution(player)) or
                (not player.eeveelution) or (not player.eeveelution.state==nil) or
                (player.eeveelution.state<EEVEE_STATE.EEVOLVING) or
                (player.eeveelution.state==EEVEE_STATE.EEVOLVED
                    and player.eeveelution.target~=player.mo.skin ) or
                (player.eeveelution.state==EEVEE_STATE.GIGAMAXED
                    and player.mo.skin~=EEVEELUTION.GIGANTAMAX.skin)
            )
        then
            player.eeveelution= nil
            continue
        end

        if not player.eeveelution then
            player.eeveelution= {
                state= EEVEE_STATE.NOTHING,
                lastLapValue= player.laps
            }
        end

        -- doing stuff when we're supposed to
        if player.eeveelution.state==EEVEE_STATE.EEVOLVING then
            eevolving(player)

            continue
        end

        if player.eeveelution.state==EEVEE_STATE.EEVOLVED then
            eevolved(player)
        end

        if player.eeveelution.state==EEVEE_STATE.MISSED then
            missedEevolution(player)
        end

        if player.eeveelution.state==EEVEE_STATE.GIGAMAXED then
            gigamaxed(player)
        end

        if not player.eeveelution then
            continue
        end


        -- preparing condition to trigger an eeveelution dice roll
        player.eeveelution.lastMareScore= ($~=nil) and $ or 0
        player.eeveelution.lastLapValue= ($~=nil) and $ or 0
        local b_triggeredChange= false
        if (not G_RaceGametype()) then
            b_triggeredChange= (player.eeveelution.lastMareScore~=player.roundscore)
        else
            b_triggeredChange= (player.eeveelution.lastLapValue~=player.laps and player.laps<r_numlaps)
        end
        player.eeveelution.lastMareScore= player.roundscore
        player.eeveelution.lastLapValue= player.laps

        -- nothing happens -> nothin to do -> ciao!
        if not b_triggeredChange then continue end

        -- in bottle, eeveelution dice roll everytime the player score changes
        if not G_RaceGametype() then
            -- Not sure if RR battle has bumpers, in any case that field is inaccessible rn
            if (player.roundscore>0) --[[and (player.kartstuff[k_bumper]>0)]] then
                local eevol_pick= P_RandomRange(1,6)
                if eevol_pick<=player.roundscore then
                    if  player.eeveelution.state==EEVEE_STATE.GIGAMAXED then
                        ungigamax(player)
                    elseif (not gigamaxRoll(player)) and player.eeveelution.state<EEVEE_STATE.EEVOLVING
                        and (not player.spinouttimer)
                    then
                        eevolve(player)
                    end
                end
            end
        -- in race eeveelution dice roll for each new lap (not of first though)
        elseif player.laps>0 then
            if player.eeveelution.state==EEVEE_STATE.GIGAMAXED then
                ungigamax(player)
            else
                local eevol_pick= P_RandomRange(1,r_numlaps)
                if (player.laps==(r_numlaps-1) or eevol_pick<=(player.laps+1)) and (player.eeveelution.state<EEVEE_STATE.EEVOLVING)
                    and (not player.spinouttimer)
                then
                    if (not gigamaxRoll(player)) then
                        eevolve(player)
                    end
                end
            end
        end
    end

    _cleaning= 1
end)

-- think you could eevolved ezpz? think again!
addHook("MobjDamage", function(pmo)
    local player = pmo.player

    if player.eeveelution and player.eeveelution.state==EEVEE_STATE.EEVOLVING then
        cancelEevolving(player)
    end
end)


addHook ("MobjThinker", function(mo)
	if mo and mo.valid
		if mo.target and mo.target.valid
			local p_target = mo.target
			P_MoveOrigin(mo, p_target.x, p_target.y, p_target.z)
			mo.angle = p_target.angle
			mo.momx = p_target.momx
			mo.momy = p_target.momy
			mo.momz = p_target.momz
		end

	end
end, MT_GMAX_PARTICLE1)



-- addHook("IntermissionThinker", function()
--     cleaning(2)
-- end)

addHook("VoteThinker", function()
    cleaning(3)
end)


-- yeah, I'm not sure tbh, don't care
--  (local HUD use only)
local function splitnum(p)
	-- yeah actually, original stuff didn't work
	-- this does the trick, go figure...
	local i=0
	for dp in displayplayers.iterate do
		if dp==p then
			return i
		end
		i= $+1
	end

	return 0
end

-- show the text at the various stage of the eeveelution
hud.add(function(v, player, camera)
    if (not player.eeveelution) or player.eeveelution.state<EEVEE_STATE.MISSED then
        return
    end

    local x= 160/((splitscreen>1) and 2 or 1)
    local y= 80/((splitscreen>=1) and 2 or 1)
    local _ev_realName= skins[EEVEELUTION.EEVEE.skin].realname

	local splitflags = 0

    if splitscreen == 1	-- 2 players
		if splitnum(player)
			splitflags = V_SPLITSCREEN --|V_SNAPTOBOTTOM
		end
	elseif splitscreen > 1 then	-- 3 or 4 players
        if splitnum(player) == 1
            splitflags = V_HORZSCREEN
        elseif splitnum(player) == 2
            splitflags = V_SPLITSCREEN --|V_SNAPTOBOTTOM
        elseif splitnum(player) == 3
            splitflags = V_SPLITSCREEN|V_HORZSCREEN --|V_SNAPTOBOTTOM
        end
    end

    if player.eeveelution.state==EEVEE_STATE.MISSED then
        local str= "Huh? ".._ev_realName:upper().." stopped evolving!"

        local w= v.stringWidth(str, V_ALLOWLOWERCASE|splitflags, "small")
        v.drawString(x-w/2, y, str, V_ALLOWLOWERCASE|splitflags, "small")

        return
    elseif player.eeveelution.state==EEVEE_STATE.GIGAMAXED then
        if player.eeveelution.timer > 3*TICRATE then return end

        local str= "GIGANTAMAX!"

        local w= v.stringWidth(str, V_ALLOWLOWERCASE|splitflags, "small")
        v.drawString(x-w/2, y, str, V_ALLOWLOWERCASE|splitflags, "small")

        return
    end

    if player.eeveelution.timer < EEVEELUTION_DURATION() then

        local str1= "What? "
        local str2= _ev_realName:upper().." is evolving!"

        local w= v.stringWidth(str1, V_ALLOWLOWERCASE|splitflags, "small") + v.stringWidth(str2, V_ALLOWLOWERCASE|splitflags, "small")

        if player.eeveelution.timer > EEVEELUTION_DURATION()/2 then
            v.drawString(x-w/2, y, (str1..str2), V_ALLOWLOWERCASE|splitflags, "small")
        else
            v.drawString(x-w/2, y, str1, V_ALLOWLOWERCASE|splitflags, "small")
        end
    elseif player.eeveelution.timer < (EEVEELUTION_DURATION() + 3*TICRATE) and player.eeveelution.target then
        local _eevol_realName= skins[player.eeveelution.target].realname

        local str= _ev_realName:upper().." evolved into ".._eevol_realName:upper().."!"

        local w= v.stringWidth(str, V_ALLOWLOWERCASE|splitflags, "small")
        v.drawString(x-w/2, y, str, V_ALLOWLOWERCASE|splitflags, "small")
    end

end)

addHook("NetVars", function(net)
	_cleaning = net($)
    r_numlaps = net($)
end)
