-- Example of how to register and eevolution for a given map
--  * the 'map' parameter is a string that this the id of the map
--  * the 'eeveelution' parameter is a table containing the eeveelution to register for given map
--       - possible value are the following strings:
--              "vaporeon", "jolteon", "flareon", "espeon", "umbreon", "leafeon", "glaceon" or "sylveon"
--
--  * encore is an optional parameter for the 'encore' version of the map.
--      If set to 'true', the eeveelution for will override the one given for the base map
--      If not given (or set to 'false'), the eeveelution for the base map and the encore version will
--          be the same.
--
-- Note: you can give several eeveelution for a map (ex: eeveelution={"espeon","glaceon"}), in this case
--      the eeveelution for each player during the game will be chose randomly

EEVEELUTION_mapRegister(
-- vanilla Race
 {map="RR_RobotnikCoaster", eeveelution={"sylveon"}}, 
 {map="RR_NorthernDistrict", eeveelution={"umbreon"}},
 {map="RR_PanicCity", eeveelution={"sylveon","vaporeon","espeon","glaceon","jolteon","leafeon"}}, 
 {map="RR_SonicSpeedway", eeveelution={"leafeon","espeon"}},
 {map="RR_GreenHills", eeveelution={"leafeon"}},
 {map="RR_EmeraldCoast", eeveelution={"vaporeon"}},
 {map="RR_StormRig", eeveelution={"jolteon"}},
 {map="RR_LucidPass", eeveelution={"flareon","espeon"}}, 
 {map="RR_AutumnRing", eeveelution={"leafeon"}},
 {map="RR_WitheringChateau", eeveelution={"sylveon","espeon","leafeon"}},
 {map="RR_PopcornWorkshop", eeveelution={"jolteon","flareon"}},
 {map="RR_SundaeDrive", eeveelution={"glaceon"}}, 
 {map="RR_CadillacCascade", eeveelution={"vaporeon","umbreon"}},
 {map="RR_Opulence", eeveelution={"sylveon","flareon","umbreon","glaceon","jolteon"}},
 {map="RR_RumbleRidge", eeveelution={"flareon"}},
 {map="RR_AngelIsland", eeveelution={"leafeon","vaporeon"}},
 {map="RR_RoastedRuins", eeveelution={"flareon"}},
 {map="RR_ObsidianOasis", eeveelution={"vaporeon","umbreon"}},
 {map="RR_MirageSaloon", eeveelution={"flareon","espeon"}},
 {map="RR_RegalRuin", eeveelution={"sylveon","umbreon"}},
 {map="RR_IsolatedIsland", eeveelution={"jolteon","vaporeon"}},
 {map="RR_Gigapolis", eeveelution={"sylveon","umbreon","glaceon","jolteon"}},
 {map="RR_DarkvileCastle1", eeveelution={"umbreon","jolteon","leafeon"}},
 {map="RR_BronzeLake", eeveelution={"vaporeon"}},
 {map="RR_CollisionChaos", eeveelution={"sylveon"}},
 {map="RR_EmeraldHill", eeveelution={"leafeon"}},
 {map="RR_AzureCity", eeveelution={"sylveon","espeon","umbreon"}},
 {map="RR_GustPlanet", eeveelution={"jolteon"}},
 {map="RR_MysticCave", eeveelution={"umbreon"}},
 {map="RR_Joypolis", eeveelution={"sylveon"}},
 {map="RR_HillTop", eeveelution={"flareon","jolteon"}},
 {map="RR_MarbleGarden", eeveelution={"glaceon","flareon","glaceon","jolteon"}},
 {map="RR_SilvercloudIsland", eeveelution={"glaceon","espeon"}},
 {map="RR_SubZeroPeak", eeveelution={"glaceon"}},
 {map="RR_LaunchBase", eeveelution={"glaceon","jolteon"}}, 
 {map="RR_AzureLake", eeveelution={"vaporeon","espeon","glaceon","leafeon"}},
 {map="RR_BalloonPark", eeveelution={"sylveon"}},
 {map="RR_ChromeGadget", eeveelution={"umbreon","jolteon"}},
 {map="RR_DesertPalace", eeveelution={"flareon"}},
 {map="RR_EndlessMine", eeveelution={"umbreon",}},
 {map="RR_PicoPark", eeveelution={"sylveon","jolteon"}},
 {map="RR_CityEscape", eeveelution={"jolteon","espeon"}},
 {map="RR_PalmtreePanic", eeveelution={"leafeon"}},
 {map="RR_DarkvileCastle2", eeveelution={"glaceon","umbreon"}},
 {map="RR_ScarletGardens", eeveelution={"vaporeon","leafeon"}},
 {map="RR_MotobugMotorway", eeveelution={"sylveon","vaporeon","glaceon","umbreon","jolteon","leafeon"}},
 {map="RR_StarLight", eeveelution={"umbreon","jolteon"}},
 {map="RR_Metropolis", eeveelution={"flareon","jolteon"}},
 {map="RR_FrozenProduction", eeveelution={"glaceon"}}, 
 {map="RR_AqueductCrystal", eeveelution={"vaporeon"}},
 {map="RR_NovaShore", eeveelution={"vaporeon"}},
 {map="RR_Hydrocity", eeveelution={"vaporeon"}},
 {map="RR_TrapTower", eeveelution={"flareon","jolteon"}},
 {map="RR_DiamondDust", eeveelution={"glaceon"}},
 {map="RR_BlueMountain1", eeveelution={"glaceon"}},
 {map="RR_BlueMountain2", eeveelution={"glaceon"}},
 {map="RR_SpeedHighway", eeveelution={"flareon","jolteon"}},
 {map="RR_CarnivalNight", eeveelution={"sylveon","vaporeon","jolteon"}},
 {map="RR_DarkFortress", eeveelution={"flareon","umbreon"}}, 
 {map="RR_SpringYard", eeveelution={"sylveon","umbreon"}}, 
 {map="RR_Labyrinth", eeveelution={"vaporeon"}}, 
 {map="RR_HotShelter", eeveelution={"flareon","umbreon","jolteon"}}, 
 {map="RR_SkySanctuary", eeveelution={"espeon","glaceon"}}, 
 {map="RR_LostColony", eeveelution={"jolteon","umbreon"}}, 
 {map="RR_DeathEgg", eeveelution={"jolteon","umbreon"}}, 
 {map="RR_765Stadium", eeveelution={"sylveon"}}, 
 {map="RR_SunsetHill", eeveelution={"leafeon",}}, 
 {map="RR_SavannahCitadel", eeveelution={"leafeon","espeon"}}, 
 {map="RR_UmbrellaRushwinds", eeveelution={"vaporeon","umbreon"}}, 
 {map="RR_AvantGarden", eeveelution={"flareon","espeon","glaceon"}}, 
 {map="RR_BigtimeBreakdown", eeveelution={"sylveon","umbreon","espeon"}}, 
 {map="RR_VantablackViolet", eeveelution={"vaporeon","umbreon"}},
 {map="RR_AuroraAtoll", eeveelution={"vaporeon","leafeon"}},
 {map="RR_DaytonaSpeedway", eeveelution={"jolteon","espeon","leafeon","glaceon"}},
 {map="RR_TurquoiseHill", eeveelution={"leafeon","espeon"}},
 {map="RR_WeissWaterway", eeveelution={"vaporeon"}},
 {map="RR_IceParadise", eeveelution={"glaceon"}},
 {map="RR_SunsplashedGetaway", eeveelution={"vaporeon","sylveon"}},
 {map="RR_FaeFalls", eeveelution={"sylveon","flareon"}},
 {map="RR_AzureAxiom", eeveelution={"vaporeon","umbreon"}},
 {map="RR_HanagumiHall", eeveelution={"sylveon"}},
 {map="RR_AerialHighlands", eeveelution={"espeon","glaceon","jolteon"}},
 {map="RR_CrispyCanyon", eeveelution={"flareon"}},
 {map="RR_TechnologyTundra", eeveelution={"jolteon","glaceon"}},
 {map="RR_OperatorsOverspace", eeveelution={"umbreon","sylveon","jolteon"}},
 {map="RR_MegaGreenHill", eeveelution={"leafeon","sylveon"}},
 {map="RR_MegaBridge", eeveelution={"leafeon","vaporeon"}},
 {map="RR_MegaLavaReef", eeveelution={"flareon"}},
 {map="RR_MegaIceCap", eeveelution={"glaceon"}},
 {map="RR_MegaScrapBrain", eeveelution={"jolteon","umbreon"}},
 {map="RR_EspressoLane", eeveelution={"vaporeon","sylveon"}},
 {map="RR_MeltyManor", eeveelution={"flareon","umbreon"}},
 {map="RR_LeafStorm", eeveelution={"leafeon","flareon"}},
 {map="RR_LakeMargorite", eeveelution={"vaporeon","espeon"}},
 {map="RR_EndlessMine2", eeveelution={"umbreon"}},
 {map="RR_CyanBelltower", eeveelution={"flareon","glaceon"}},
 {map="RR_QuartzQuadrant", eeveelution={"jolteon","glaceon"}},
 {map="RR_AquaTunnel", eeveelution={"vaporeon"}},
 {map="RR_WaterPalace", eeveelution={"vaporeon"}},
 {map="RR_FinalFall", eeveelution={"espeon","flareon","jolteon","glaceon"}},
 {map="RR_HauntedShip", eeveelution={"jolteon","umbreon"}},
 {map="RR_RobotnikWinter", eeveelution={"glaceon"}},
 {map="RR_DragonspireSewer1", eeveelution={"vaporeon"}},
 {map="RR_AbyssGarden", eeveelution={"espeon","umbreon"}},
 {map="RR_BlizzardPeaks", eeveelution={"glaceon"}},
 {map="RR_VermilionVessel", eeveelution={"sylveon","jolteon"}},
 {map="RR_DragonspireSewer2", eeveelution={"vaporeon","umbreon"}},
 {map="RR_ChemicalFacility", eeveelution={"jolteon","umbreon"}},
 {map="RR_CoastalTemple", eeveelution={"leafeon","espeon"}},
 {map="RR_MonkeyMall", eeveelution={"flareon","umbreon","glaceon","jolteon"}},
 {map="RR_RampPark", eeveelution={"glaceon","sylveon"}},
 {map="RR_AdventAngel", eeveelution={"sylveon","jolteon"}},
 {map="RR_Pestilence", eeveelution={"vaporeon","umbreon"}},
 {map="RR_CrimsonCore", eeveelution={"flareon"}},
 {map="RR_LasVegas", eeveelution={"flareon","sylveon"}},
 {map="RR_MegaCollisionChaos", eeveelution={"sylveon"}},
 {map="RR_MegaStarLight", eeveelution={"jolteon"}},
 {map="RR_MegaSandopolis", eeveelution={"flareon","umbreon"}},
 {map="RR_MegaAquaLake", eeveelution={"vaporeon","glaceon"}},
 {map="RR_MegaFlyingBattery", eeveelution={"jolteon","glaceon"}},
 {map="RR_SkyBabylon", eeveelution={"glaceon","jolteon","flareon"}},
 {map="RR_KodachromeVoid", eeveelution={"flareon","jolteon"}},
 {map="RR_LavenderShrine", eeveelution={"sylveon","umbreon","espeon"}},
 {map="RR_ThunderPiston", eeveelution={"jolteon"}},
 {map="RR_DeadLine", eeveelution={"flareon","jolteon"}},
 {map="RR_SRB2FrozenNight", eeveelution={"glaceon"}},
 {map="RR_BarrenBadlands", eeveelution={"flareon"}},
 {map="RR_ShuffleSquare", eeveelution={"sylveon","umbreon"}},
 {map="RR_BlueMountainClassic", eeveelution={"glaceon"}},
 {map="RR_AngelArrowClassic", eeveelution={"vaporeon","jolteon","sylveon"}},
 {map="RR_CadillacCanyonClassic", eeveelution={"leafeon","sylveon"}},
 {map="RR_DiamondDustClassic", eeveelution={"glaceon"}},
 {map="RR_BlizzardPeaksClassic", eeveelution={"glaceon"}},
 {map="RR_LaunchBaseClassic", eeveelution={"jolteon"}},
 {map="RR_LavenderShrineClassic", eeveelution={"vaporeon","umbreon"}},

-- Special Stage
 {map="RR_SealedStarBalconies", eeveelution={"leafeon"}},
 {map="RR_SealedStarChurch", eeveelution={"jolteon"}},
 {map="RR_SealedStarCourtyard", eeveelution={"sylveon"}},
 {map="RR_SealedStarVilla", eeveelution={"glaceon"}},
 {map="RR_SealedStarVenice", eeveelution={"vaporeon"}},
 {map="RR_SealedStarSpikes", eeveelution={"flareon"}},
 {map="RR_SealedStarFountain", eeveelution={"vaporeon"}},
 {map="RR_SealedStarGallery", eeveelution={"espeon"}},
 {map="RR_SealedStarAlley", eeveelution={"jolteon"}},
 {map="RR_SealedStarSteeple", eeveelution={"sylveon"}},
 {map="RR_SealedStarRooftops", eeveelution={"espeon"}},
 {map="RR_SealedStarRoulette", eeveelution={"flareon"}},
 {map="RR_SealedStarTowers", eeveelution={"espeon"}},
 {map="RR_SealedStarAtlantis", eeveelution={"umbreon"}}
 )